// $Id: nasdsim_event_N2N.h,v 1.1 2000/04/24 23:03:59 ozaki Exp $

#if !defined(NASDSIM_EVENT_N2N_H)
#define NASDSIM_EVENT_N2N_H

#include "nasdsim_event.h"
#include "nasdsim_types.h"
#include "nasdsim_components.h"
#include "nasdsim_param.h"

class event_N2N_nasd_send_to_switch : public event
{
 private:
  
    param_nasd_2_nasd *parameter;
  
 public:
  
    event_N2N_nasd_send_to_switch (simtime_t stT, simtime_t inT, param_nasd_2_nasd *p)
      : event (stT, inT), parameter (p) {};
    ~event_N2N_nasd_send_to_switch () {};
    events_t *simulate(components &comp);
    
#if defined (DEBUG)
    void print(ostream &o)const;
#endif
};

class event_N2N_switch_recv_from_nasd : public event
{
 private:
  
    param_nasd_2_nasd *parameter;
    
 public:
    
    event_N2N_switch_recv_from_nasd (simtime_t stT, simtime_t inT,
				     param_nasd_2_nasd *p)
	: event (stT, inT), parameter (p) {};
    ~event_N2N_switch_recv_from_nasd () {};
    events_t *simulate(components &comp);
    
#if defined (DEBUG)
    void print(ostream &o)const;
#endif
};

class event_N2N_switch_send_to_nasd : public event
{
 private:
  
    param_nasd_2_nasd *parameter;
  
 public:
  
  event_N2N_switch_send_to_nasd (simtime_t stT, simtime_t inT, param_nasd_2_nasd *p)
      : event (stT, inT), parameter (p) {};
  ~event_N2N_switch_send_to_nasd () {};
  events_t *simulate(components &comp);

#if defined (DEBUG)
  void print(ostream &o)const;
#endif
};

class event_N2N_nasd_recv_from_switch : public event
{
 private:
  
    param_nasd_2_nasd *parameter;
  
 public:
  
  event_N2N_nasd_recv_from_switch (simtime_t stT, simtime_t inT, param_nasd_2_nasd *p)
: event (stT, inT), parameter (p) {};
  ~event_N2N_nasd_recv_from_switch () {};
  events_t *simulate(components &comp);
  
#if defined (DEBUG)
  void print(ostream &o)const;
#endif

};

#endif // #define NASDSIM_EVENT_N2N_H
